'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _ripple = require('../ripple');

var _ripple2 = _interopRequireDefault(_ripple);

var _utilsEvents = require('../utils/events');

var _utilsEvents2 = _interopRequireDefault(_utilsEvents);

var _style = require('./style');

var _style2 = _interopRequireDefault(_style);

var Checkbox = (function (_React$Component) {
  _inherits(Checkbox, _React$Component);

  function Checkbox() {
    var _this = this;

    _classCallCheck(this, Checkbox);

    _get(Object.getPrototypeOf(Checkbox.prototype), 'constructor', this).apply(this, arguments);

    this.handleClick = function (event) {
      _utilsEvents2['default'].pauseEvent(event);
      if (!_this.props.disabled && _this.props.onChange) {
        var value = !_this.refs.input.checked;
        _this.props.onChange(value, event);
      }
    };

    this.handleInputClick = function (event) {
      _utilsEvents2['default'].pauseEvent(event);
    };

    this.handleMouseDown = function (event) {
      if (!_this.props.disabled) {
        _this.refs.ripple.start(event);
      }
    };
  }

  _createClass(Checkbox, [{
    key: 'blur',
    value: function blur() {
      this.refs.input.blur();
    }
  }, {
    key: 'focus',
    value: function focus() {
      this.refs.input.focus();
    }
  }, {
    key: 'render',
    value: function render() {
      var fieldClassName = (0, _classnames2['default'])(_style2['default'].field, _defineProperty({}, _style2['default'].disabled, this.props.disabled), this.props.className);

      var checkboxClassName = (0, _classnames2['default'])(_style2['default'].check, _defineProperty({}, _style2['default'].checked, this.props.checked));

      return _react2['default'].createElement(
        'label',
        {
          'data-react-toolbox': 'checkbox',
          className: fieldClassName,
          onClick: this.handleClick
        },
        _react2['default'].createElement('input', _extends({
          ref: 'input'
        }, this.props, {
          className: _style2['default'].input,
          onClick: this.handleInputClick,
          type: 'checkbox'
        })),
        _react2['default'].createElement(
          'span',
          { 'data-role': 'checkbox', className: checkboxClassName, onMouseDown: this.handleMouseDown },
          _react2['default'].createElement(_ripple2['default'], { ref: 'ripple', 'data-role': 'ripple', className: _style2['default'].ripple, spread: 3, centered: true })
        ),
        this.props.label ? _react2['default'].createElement(
          'span',
          { 'data-role': 'label', className: _style2['default'].text },
          this.props.label
        ) : null
      );
    }
  }], [{
    key: 'propTypes',
    value: {
      checked: _react2['default'].PropTypes.bool,
      className: _react2['default'].PropTypes.string,
      disabled: _react2['default'].PropTypes.bool,
      label: _react2['default'].PropTypes.any,
      name: _react2['default'].PropTypes.string,
      onBlur: _react2['default'].PropTypes.func,
      onChange: _react2['default'].PropTypes.func,
      onFocus: _react2['default'].PropTypes.func
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      checked: false,
      className: '',
      disabled: false
    },
    enumerable: true
  }]);

  return Checkbox;
})(_react2['default'].Component);

exports['default'] = Checkbox;
module.exports = exports['default'];